package com.qmth.ops.api.controller.open;

import com.qmth.boot.api.annotation.Aac;
import com.qmth.boot.api.annotation.BOOL;
import com.qmth.boot.core.solar.model.AppInfo;
import com.qmth.boot.tools.signature.SignatureType;
import com.qmth.ops.api.constants.OpsApiConstants;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping(OpsApiConstants.OPEN_URI_PREFIX)
@Aac(auth = BOOL.TRUE, signType = SignatureType.SECRET)
public class OpenAppDeployController {

    @PostMapping("/app/info")
    @Aac(auth = BOOL.FALSE)
    public AppInfo getAppInfo() {
        AppInfo info = new AppInfo();
        info.setId(123L);
        info.setName("测试应用");
        return info;
    }
}
