package com.qmth.ops.biz.service;

import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.qmth.ops.biz.dao.OrgDao;
import com.qmth.ops.biz.domain.Org;
import com.qmth.ops.biz.query.OrgQuery;
import org.apache.commons.lang3.RandomStringUtils;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.List;
import java.util.UUID;

@Service
public class OrgService {

    @Resource
    private OrgDao orgDao;

    public OrgQuery findByQuery(OrgQuery query) {
        return orgDao.findByQuery(query);
    }

    public List<Org> listByQuery(OrgQuery query) {
        return orgDao.findByQuery(query).getRecords();
    }

    @Transactional
    public boolean toggle(Long id, boolean enable) {
        return orgDao.toggle(id, enable) > 0;
    }

    @Transactional
    public Org insert(Org org) {
        org.setAccessKey(UUID.randomUUID().toString().replaceAll("-", ""));
        org.setAccessSecret(RandomStringUtils.random(32, true, true));
        org.setCreateTime(System.currentTimeMillis());
        org.setUpdateTime(org.getCreateTime());
        orgDao.insert(org);
        return org;
    }

    @Transactional
    public Org update(Org org) {
        orgDao.update(org, new LambdaUpdateWrapper<Org>().set(org.getCode() != null, Org::getCode, org.getCode())
                .set(org.getName() != null, Org::getName, org.getName())
                .set(org.getType() != null, Org::getType, org.getType())
                .set(org.getSubTypes() != null, Org::getSubTypes, org.getSubTypes())
                .set(org.getLogo() != null, Org::getLogo, org.getLogo())
                .set(Org::getUpdateTime, System.currentTimeMillis()).eq(Org::getId, org.getId()));
        return orgDao.selectById(org.getId());
    }
}
